﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Anwendung                                                                           //
//  _________________________________  													//
//																						//
//  Copyright (c) 2019 Reimar Grasbon                                                   //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "TypeDefs.h"

//////////////////////////////////////////////////////////////////////////////////////////
//  Typen  ///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
typedef enum                    // Signale der Info- und System-LED:
{   LEDSIGNAL_OFF          = 0,  // · Kein Signal, Ausgeschaltet (Voreinstellung).
	LEDSIGNAL_ON           = 1,  // · Leuchtet durchgehend.
	LEDSIGNAL_HEARTBEAT    = 2,  // · Herzschlag-Signal. 
	LEDSIGNAL_BUS_ACTIVITY = 3,  // · Leuchtet bei Busaktivität.
	LEDSIGNAL_RADIO_GOOD   = 4,  // · Ein = Funkzeit wird empfangen.
	LEDSIGNAL_RADIO_BAD    = 5,  // · Ein = Funkzeitempfang fehlerhaft.
	LEDSIGNAL_DCF_FAIL     = 6,  // · Blinkt, wenn letzter Zeitempf. mehr als eine Woche zurückliegt.
	LEDSIGNAL_RTC_FAIL     = 7   // · Blinkt bei Kommunikationsproblemen mit der Echtzeituhr.
} LedSignal;

typedef enum                    // Sommerzeit-Betriebsart
{   DSTMODE_OFF  =  0,          // · Aus: Normalzeit
	DSTMODE_ON   =  1,          // · Ein: Sommerzeit gem.  MESZ, (Normalzeit+1 Stunde)
	DSTMODE_AUTO =  2,          // · Automatische Umschaltung
	DSTMODE_DCF  =  3           // · Umschaltung gemäß empfangener Funkzeit (wenn möglich)
} DSTMode;

//////////////////////////////////////////////////////////////////////////////////////////
//  Prozessaufrufe  //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void    APPLICATION_Startup(void);
void    APPLICATION_Proceed(void);
void    APPLICATION_Shutdown(void);

//////////////////////////////////////////////////////////////////////////////////////////

